#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int hracu,vyroku;
char jmena[11][20];

struct token {
	enum { invalid,
	cislo, plus, rovna,
	jmeno,
	je, kdo, rika,
	jetotak, koho, operator,
	lzav, pzav, uvozovky, tecka,
	a,
	eoln} typ;
	int cislo;
};

struct vyrok {
	enum { Rovnice, Kdo, Rika, Pocet, Spojka } typ;
	int a,b,c;
	int kdo,co;
	struct vyrok *v1,*v2;
	int nazor;
	int pocet,koho,operator;
	int spojka;
};

#define osetri(retezec,token,kolik) {\
	if(!strncmp(r,retezec,sizeof(retezec)-1)){\
		vysl->typ=token;\
		vysl->cislo=kolik;\
		r+=sizeof(retezec)-1;\
		goto konec;\
	}\
}
int scantoken(char **ret,struct token *vysl){
	char *r=*ret;
	int i;

	while(r[0]==' ')
		r++;
	if(!r[0]){
		vysl->typ=eoln;
		goto konec;
	}
	osetri("Poctivcu",koho,1);
	osetri("Lharu",koho,0);
	for(i=0;i<hracu;i++)
		osetri(jmena[i],jmeno,i);
	if(r[0]>='0' && r[0]<='9'){
		vysl->typ=cislo;
		vysl->cislo=0;
		while(r[0]>='0' && r[0]<='9'){
			vysl->cislo=vysl->cislo*10+r[0]-'0';
			r++;
		}
		goto konec;
	}
	if(r[0]=='+'){
		vysl->typ=plus;
		r++;
		goto konec;
	}
	if(r[0]=='='){
		vysl->typ=rovna;
		r++;
		goto konec;
	}
	if(r[0]=='"'){
		vysl->typ=uvozovky;
		r++;
		goto konec;
	}
	if(r[0]=='('){
		vysl->typ=lzav;
		r++;
		goto konec;
	}
	if(r[0]==')'){
		vysl->typ=pzav;
		r++;
		goto konec;
	}
	if(r[0]=='.'){
		vysl->typ=tecka;
		r++;
		goto konec;
	}
	osetri("je",je,0);
	osetri("poctivec",kdo,1);
	osetri("lhar",kdo,0);
	osetri("rika",rika,0);
	osetri("a je to opravdu tak",jetotak,1);
	osetri(", ale neni to pravda",jetotak,0);
	osetri("je mene nez",operator,1);
	osetri("je vice nez",operator,2);
	osetri("je alespon",operator,3);
	osetri("a zaroven",a,1);
	osetri("nebo",a,0);
	vysl->typ=invalid;

konec:
	while(r[0]==' ')
		r++;
	*ret=r;

	return 0;
}

struct vyrok * scanvyrok(char **ret){
	struct vyrok *novy=calloc(1,sizeof(struct vyrok));
	struct token tok;

#define chci(co) {\
	scantoken(ret,&tok);\
	if(tok.typ!=co)\
		return NULL;\
}
	scantoken(ret,&tok);
	switch(tok.typ){
	case cislo:
		novy->typ=Rovnice;
		novy->a=tok.cislo;
		chci(plus);
		chci(cislo);
		novy->b=tok.cislo;
		chci(rovna);
		chci(cislo);
		novy->c=tok.cislo;
		break;
	case jmeno:
		novy->kdo=tok.cislo;
		scantoken(ret,&tok);
		switch(tok.typ){
		case je:
			novy->typ=Kdo;
			chci(kdo);
			novy->co=tok.cislo;
			break;
		case rika:
			novy->typ=Rika;
			chci(uvozovky);
			if(!(novy->v1=scanvyrok(ret)))
				return NULL;
			chci(uvozovky);
			scantoken(ret,&tok);
			switch(tok.typ){
			case tecka:
				novy->nazor=0;
				break;
			case jetotak:
				novy->nazor=1+tok.cislo;
				break;
			default:
				return NULL;
			}
		default:
			return NULL;
		}
	case koho:
		novy->typ=Pocet;
		novy->koho=tok.cislo;
		chci(operator);
		novy->operator=tok.cislo;
		chci(cislo);
		novy->pocet=tok.cislo;
		break;
	case lzav:
		novy->typ=Spojka;
		if(!(novy->v1=scanvyrok(ret)))
			return NULL;
		chci(pzav);
		chci(a);
		novy->spojka=tok.cislo;
		chci(lzav);
		if(!(novy->v2=scanvyrok(ret)))
			return NULL;
		chci(pzav);
		break;
	default:
		return NULL;
	}
	if(**ret)
		return NULL;
	return novy;
}

int vyhodnot(int hrac,struct vyrok *v, int *ohodnoceni){
	int pravda=0,p1,p2;
	int i,pocet;

	switch(v->typ){
	case Rovnice:
		pravda=(v->a+v->b==v->c);
		break;
	case Kdo:
		pravda=ohodnoceni[v->kdo]==v->co;
		break;
	case Rika:
		p1=vyhodnot(v->kdo,v->v1,ohodnoceni);
		p2=vyhodnot(hrac,v->v1,ohodnoceni);
		switch(v->nazor){
		case 0:
			pravda=p1;
			break;
		case 1:
		case 2:
			if(p1!=p2)
				return 100;
			else
				pravda=p1;
		default:
			return 200;
		}
	case Pocet:
		pocet=0;
		for(i=0;i<hracu;i++)
		if(ohodnoceni[i]==v->koho)
			pocet++;
		switch(v->operator){
		case 1:
			pravda=pocet<v->pocet;
			break;
		case 2:
			pravda=pocet>v->pocet;
			break;
		case 3:
			pravda=pocet>=v->pocet;
			break;
		default:
			return 300;
		}
	case Spojka:
		p1=vyhodnot(hrac,v->v1,ohodnoceni);
		p2=vyhodnot(hrac,v->v2,ohodnoceni);
		switch(v->spojka){
		case 1:
			pravda=p1 && p2;
			break;
		case 0:
			pravda=p1 || p2;
			break;
		default:
			return 400;
		}
	default:
		return 500;
	}
	pravda ^= ohodnoceni[hrac];
	return pravda ? 1 : 0;
}

void res(){
	int i;

	scanf("\n%d\n",&hracu);
	for(i=0;i<hracu;i++)
		gets(jmena[i]);
	scanf("%d\n",&vyroku);
	
}

int main(){
	int i,pocet;
	scanf("%d\n",&pocet);
	for(i=0;i<pocet;i++)
		res();
	return 0;
}
